#!/usr/bin/env node --harmony

const co = require('co');
const prompt = require('co-prompt');
const program = require('commander');
const { copy } = require("./utils/index.js")
const path = require("path")

const defaultConfig = {
    name: `kualp_v${Date.now()}`
}

program
    .command('init')
    .description('To create a base project for gulp')
    .action(function () {
        co(function* () {
            var params = {};
            params.type = yield prompt('Page project type (pc/mobile): ');

            if (params.type !== "pc" || params.type !== "pc") {
                console.info("Please to input pc or mobile");
                process.exit(0);
            }

            params.name = yield prompt('Project dirname: ');

            // 是否同意
            var agree = yield prompt('Is this ok? (y/n)');

            let name = params.name === "undefined" || !params.name ? defaultConfig.name : params.name

            // 过滤名称
            name = name.replace(/(\.|\\|\/)/ig, "");

            if (agree === "y") {
                try {
                    console.info(`${"\033[47;30m"} creating... ${"\33[0m"}`)
                    copy(path.resolve(__dirname, "./" + params.type), (`${process.cwd()}${path.sep}${name}${path.sep}`)).then(res => {
                        console.clear()
                        console.info(`${"\033[44;"}30mSuccessfully create!${"\033[0m"}`)
                        console.info(`${"\033[44;30m"}cd ${process.cwd()}${path.sep}${name} and yarn ${"\033[0m"}`)
                        process.exit(0);
                    })
                } catch (e) {
                    console.error(e)
                }
            } else {
                process.exit(0);
            }
        });
    });

program.parse(process.argv)